<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>discover: /home/pere/src/debiancvs/pkg-discover/discover/trunk/include/discover/discover.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.4.2 -->
<div class="qindex"><a class="qindex" href="index.html">Main&nbsp;Page</a> | <a class="qindex" href="modules.html">Modules</a> | <a class="qindex" href="annotated.html">Data&nbsp;Structures</a> | <a class="qindex" href="dirs.html">Directories</a> | <a class="qindex" href="files.html">File&nbsp;List</a> | <a class="qindex" href="functions.html">Data&nbsp;Fields</a> | <a class="qindex" href="globals.html">Globals</a></div>
<div class="nav">
<a class="el" href="dir_000000.html">include</a>&nbsp;/&nbsp;<a class="el" href="dir_000001.html">discover</a></div>
<h1>discover.h</h1><a href="discover_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment">00001 
00006 <span class="comment">/* $Progeny$</span>
00007 <span class="comment"> *</span>
00008 <span class="comment"> * Copyright 2001, 2002 Progeny Linux Systems, Inc.</span>
00009 <span class="comment"> * Copyright 2002 Hewlett-Packard Company</span>
00010 <span class="comment"> *</span>
00011 <span class="comment"> * Permission is hereby granted, free of charge, to any person obtaining a</span>
00012 <span class="comment"> * copy of this software and associated documentation files (the "Software"),</span>
00013 <span class="comment"> * to deal in the Software without restriction, including without limitation</span>
00014 <span class="comment"> * the rights to use, copy, modify, merge, publish, distribute, sublicense,</span>
00015 <span class="comment"> * and/or sell copies of the Software, and to permit persons to whom the</span>
00016 <span class="comment"> * Software is furnished to do so, subject to the following conditions:</span>
00017 <span class="comment"> *</span>
00018 <span class="comment"> * The above copyright notice and this permission notice shall be included in</span>
00019 <span class="comment"> * all copies or substantial portions of the Software.</span>
00020 <span class="comment"> *</span>
00021 <span class="comment"> * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
00022 <span class="comment"> * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
00023 <span class="comment"> * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL</span>
00024 <span class="comment"> * THE COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
00025 <span class="comment"> * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING</span>
00026 <span class="comment"> * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER</span>
00027 <span class="comment"> * DEALINGS IN THE SOFTWARE.</span>
00028 <span class="comment"> */</span>
00029 
00030 <span class="preprocessor">#ifndef DISCOVER_H</span>
00031 <span class="preprocessor"></span><span class="preprocessor">#define DISCOVER_H</span>
00032 <span class="preprocessor"></span>
00033 <span class="preprocessor">#include &lt;stdbool.h&gt;</span>
00034 
00035 <span class="preprocessor">#ifdef __cplusplus</span>
00036 <span class="preprocessor"></span>    <span class="keyword">extern</span> <span class="stringliteral">"C"</span> {
00037 <span class="preprocessor">#endif</span>
00038 <span class="preprocessor"></span>
<a name="l00073"></a><a class="code" href="group__types.html#ga15">00073</a> <span class="keyword">typedef</span> <span class="keyword">enum</span> {
00075     <a class="code" href="group__types.html#gga15a15">DISCOVER_SUCCESS</a>,
00077     <a class="code" href="group__types.html#gga15a16">DISCOVER_EIO</a>,
00079     <a class="code" href="group__types.html#gga15a17">DISCOVER_EXML</a>,
00081     <a class="code" href="group__types.html#gga15a18">DISCOVER_ESYS</a>,
00083     <a class="code" href="group__types.html#gga15a19">DISCOVER_EBUSDISABLED</a>,
00085     <a class="code" href="group__types.html#gga15a20">DISCOVER_EBUSNOTFOUND</a>,
00087     <a class="code" href="group__types.html#gga15a21">DISCOVER_EDATANOTFOUND</a>,
00089     <a class="code" href="group__types.html#gga15a22">DISCOVER_EDEVICENOTFOUND</a>,
00091     <a class="code" href="group__types.html#gga15a23">DISCOVER_EBADVERSION</a>,
00093     <a class="code" href="group__types.html#gga15a24">DISCOVER_ENOIMPL</a>
00094 } <a class="code" href="group__types.html#ga15">discover_error_code_t</a>;
00095 
00096 <span class="keyword">struct </span><a class="code" href="structdiscover__error.html">discover_error</a>;
00097 
<a name="l00099"></a><a class="code" href="group__types.html#ga0">00099</a> <span class="keyword">typedef</span> <span class="keywordtype">void</span> *(<a class="code" href="group__types.html#ga0">discover_create_message_t</a>)(<span class="keyword">struct </span><a class="code" href="structdiscover__error.html">discover_error</a> **, <span class="keywordtype">char</span> *);
00100 
<a name="l00106"></a><a class="code" href="structdiscover__error.html">00106</a> <span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="structdiscover__error.html">discover_error</a> {
<a name="l00108"></a><a class="code" href="structdiscover__error.html#o0">00108</a>     discover_error_code_t <a class="code" href="structdiscover__error.html#o0">code</a>;
<a name="l00110"></a><a class="code" href="structdiscover__error.html#o1">00110</a>     <span class="keywordtype">char</span> *<a class="code" href="structdiscover__error.html#o1">message</a>;
<a name="l00112"></a><a class="code" href="structdiscover__error.html#o2">00112</a>     <a class="code" href="group__types.html#ga0">discover_create_message_t</a> *<a class="code" href="structdiscover__error.html#o2">create_message</a>;
00113 } <a class="code" href="structdiscover__error.html">discover_error_t</a>;
00114 
<a name="l00116"></a><a class="code" href="group__types.html#ga2">00116</a> <span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="structdiscover__bus__map.html">discover_bus_map</a>         discover_bus_map_t;
<a name="l00118"></a><a class="code" href="group__types.html#ga3">00118</a> <span class="keyword">typedef</span> <span class="keyword">struct </span>discover_device          discover_device_t;
<a name="l00120"></a><a class="code" href="group__types.html#ga4">00120</a> <span class="keyword">typedef</span> <span class="keyword">struct </span>discover_data            discover_data_t;
<a name="l00122"></a><a class="code" href="group__types.html#ga5">00122</a> <span class="keyword">typedef</span> <span class="keyword">struct </span>discover_xml_busclass    discover_xml_busclass_t;
<a name="l00124"></a><a class="code" href="group__types.html#ga6">00124</a> <span class="keyword">typedef</span> <span class="keyword">struct </span>discover_xml_vendor      discover_xml_vendor_t;
<a name="l00126"></a><a class="code" href="group__types.html#ga7">00126</a> <span class="keyword">typedef</span> <span class="keyword">struct </span>discover_xml_url         discover_xml_url_t;
00127 
<a name="l00129"></a><a class="code" href="group__types.html#ga8">00129</a> <span class="keyword">typedef</span> discover_device_t *(<a class="code" href="group__types.html#ga8">discover_device_func_t</a>)(<a class="code" href="structdiscover__error.html">discover_error_t</a> *);
<a name="l00131"></a><a class="code" href="group__types.html#ga9">00131</a> <span class="keyword">typedef</span> discover_xml_busclass_t *(<a class="code" href="group__types.html#ga9">discover_xml_busclass_func_t</a>)(<a class="code" href="structdiscover__error.html">discover_error_t</a> *);
<a name="l00133"></a><a class="code" href="group__types.html#ga10">00133</a> <span class="keyword">typedef</span> discover_xml_vendor_t *(<a class="code" href="group__types.html#ga10">discover_xml_vendor_func_t</a>)(<a class="code" href="structdiscover__error.html">discover_error_t</a> *);
<a name="l00135"></a><a class="code" href="group__types.html#ga11">00135</a> <span class="keyword">typedef</span> discover_xml_url_t *(<a class="code" href="group__types.html#ga11">discover_xml_url_func_t</a>)(<a class="code" href="structdiscover__error.html">discover_error_t</a> *);
<a name="l00137"></a><a class="code" href="group__types.html#ga12">00137</a> <span class="keyword">typedef</span> void (<a class="code" href="group__types.html#ga12">discover_free_func_t</a>)(void);
00138 
00139 <span class="preprocessor">#include &lt;<a class="code" href="sysdep_8h.html">discover/sysdep.h</a>&gt;</span>
<a name="l00141"></a><a class="code" href="group__types.html#ga13">00141</a> <span class="keyword">typedef</span> <a class="code" href="structdiscover__sysdep__data.html">discover_sysdep_data_t</a> *(<a class="code" href="group__types.html#ga13">discover_sysdep_raw_func_t</a>)(void);
00142 
<a name="l00146"></a><a class="code" href="group__types.html#ga16">00146</a> <span class="keyword">typedef</span> <span class="keyword">enum</span> {
00147     ATA,
00148     PCI,
00149     PCMCIA,
00150     SCSI,
00151     USB
00152 } <a class="code" href="group__types.html#ga16">discover_bus_t</a>;
00153 
<a name="l00157"></a><a class="code" href="group__types.html#ga14">00157</a> <span class="preprocessor">#define BUS_COUNT 5</span>
00158 <span class="preprocessor"></span>
<a name="l00162"></a><a class="code" href="group__types.html#ga17">00162</a> <span class="keyword">typedef</span> <span class="keyword">enum</span> {
00163     VENDOR_TYPE,
00164     BUSCLASS_TYPE,
00165     DEVICE_TYPE
00166 } <a class="code" href="group__types.html#ga17">discover_filetype_t</a>;
00167 
00168 
<a name="l00178"></a><a class="code" href="structdiscover__bus__map.html">00178</a> <span class="keyword">struct </span><a class="code" href="structdiscover__bus__map.html">discover_bus_map</a> {
<a name="l00180"></a><a class="code" href="structdiscover__bus__map.html#o0">00180</a>     <span class="keywordtype">char</span> *<a class="code" href="structdiscover__bus__map.html#o0">name</a>;
<a name="l00182"></a><a class="code" href="structdiscover__bus__map.html#o1">00182</a>     <span class="keywordtype">int</span> <a class="code" href="structdiscover__bus__map.html#o1">scan_default</a>;
<a name="l00184"></a><a class="code" href="structdiscover__bus__map.html#o2">00184</a>     <span class="keywordtype">int</span> <a class="code" href="structdiscover__bus__map.html#o2">scan_never</a>;
<a name="l00186"></a><a class="code" href="structdiscover__bus__map.html#o3">00186</a>     <a class="code" href="group__types.html#ga13">discover_sysdep_raw_func_t</a> *<a class="code" href="structdiscover__bus__map.html#o3">get_raw</a>;
00187 };
00188 
00192 discover_device_t *<a class="code" href="sysdep_8c.html#a8">discover_get_devices</a>(discover_bus_t bus, <a class="code" href="structdiscover__error.html">discover_error_t</a> *status);
00193 
00195 <span class="keywordtype">void</span> <a class="code" href="sysdep_8c.html#a9">discover_free_devices</a>(<span class="keywordtype">void</span>);
00196 
00197 <a class="code" href="structdiscover__error.html">discover_error_t</a> *<a class="code" href="group__core.html#ga0">discover_error_new</a>(<span class="keywordtype">void</span>);
00198 <span class="keywordtype">void</span> <a class="code" href="group__core.html#ga2">discover_error_free</a>(<a class="code" href="structdiscover__error.html">discover_error_t</a> *status);
00199 <span class="keywordtype">char</span> *<a class="code" href="group__core.html#ga3">discover_strerror</a>(<a class="code" href="structdiscover__error.html">discover_error_t</a> *err);
00200 <span class="keywordtype">int</span> <a class="code" href="group__core.html#ga4">discover_major_version</a>(<span class="keywordtype">void</span>);
00201 <span class="keywordtype">int</span> <a class="code" href="group__core.html#ga5">discover_minor_version</a>(<span class="keywordtype">void</span>);
00202 <span class="keywordtype">int</span> <a class="code" href="group__core.html#ga6">discover_micro_version</a>(<span class="keywordtype">void</span>);
00203 
00204 <span class="comment">/******************************************************************************</span>
00205 <span class="comment"> * discover_device</span>
00206 <span class="comment"> */</span>
00207 
00208 discover_device_t *<a class="code" href="group__device.html#ga22">discover_device_new</a>(<span class="keywordtype">void</span>);
00209 
00210 <span class="comment">/* Class is "video", "sound", etc. */</span>
00211 discover_device_t *<a class="code" href="group__device.html#ga0">discover_device_find</a>(<span class="keywordtype">char</span> *discover_class,
00212                                              <a class="code" href="structdiscover__error.html">discover_error_t</a> *status);
00213 
00214 <span class="keywordtype">char</span> *<a class="code" href="group__device.html#ga4">discover_device_get_data</a>(discover_device_t *device,
00215                                <span class="keywordtype">char</span> *path, <span class="keywordtype">char</span> *version,
00216                                <a class="code" href="structdiscover__error.html">discover_error_t</a> *status);
00217 
00218 <span class="keywordtype">void</span>
00219 <a class="code" href="group__device.html#ga5">discover_device_copy</a>(discover_device_t *src, discover_device_t *dst);
00220 
00221 <span class="keywordtype">char</span> *<a class="code" href="group__device.html#ga15">discover_device_get_busclass</a>(discover_device_t *device);
00222 <span class="keywordtype">char</span> *<a class="code" href="group__device.html#ga16">discover_device_get_model_id</a>(discover_device_t *device);
00223 <span class="keywordtype">char</span> *<a class="code" href="group__device.html#ga17">discover_device_get_model_name</a>(discover_device_t *device);
00224 <span class="keywordtype">char</span> *<a class="code" href="group__device.html#ga18">discover_device_get_vendor_id</a>(discover_device_t *device);
00225 <span class="keywordtype">char</span> *<a class="code" href="group__device.html#ga19">discover_device_get_vendor_name</a>(discover_device_t *device);
00226 
00227 discover_data_t *
00228 <a class="code" href="group__device.html#ga20">discover_device_get_data_struct</a>(discover_device_t *device);
00229 
00230 discover_device_t *
00231 <a class="code" href="group__device.html#ga21">discover_device_get_next</a>(discover_device_t *device);
00232 
00233 <span class="keywordtype">void</span> <a class="code" href="group__device.html#ga23">discover_device_free</a>(discover_device_t *devices, <span class="keywordtype">int</span> free_data);
00234 
00235 <span class="comment">/******************************************************************************</span>
00236 <span class="comment"> * discover_data</span>
00237 <span class="comment"> */</span>
00238 
00239 discover_data_t *<a class="code" href="group__device.html#ga13">discover_data_new</a>(<span class="keywordtype">void</span>);
00240 
00241 <span class="keywordtype">char</span> *<a class="code" href="group__device.html#ga6">discover_data_get_class</a>(discover_data_t *data);
00242 <span class="keywordtype">char</span> *<a class="code" href="group__device.html#ga7">discover_data_get_text</a>(discover_data_t *data);
00243 discover_data_t *<a class="code" href="group__device.html#ga8">discover_data_get_parent</a>(discover_data_t *data);
00244 discover_data_t *<a class="code" href="group__device.html#ga9">discover_data_get_child</a>(discover_data_t *data);
00245 discover_data_t *<a class="code" href="group__device.html#ga10">discover_data_get_next</a>(discover_data_t *data);
00246 discover_data_t *<a class="code" href="group__device.html#ga11">discover_data_get_prev</a>(discover_data_t *prev);
00247 discover_data_t *<a class="code" href="group__device.html#ga12">discover_data_get_first</a>(discover_data_t *data);
00248 <span class="keywordtype">void</span> <a class="code" href="group__device.html#ga14">discover_data_free</a>(discover_data_t *data_tree);
00249 
00250 <span class="preprocessor">#ifdef __cplusplus</span>
00251 <span class="preprocessor"></span>    }
00252 <span class="preprocessor">#endif</span>
00253 <span class="preprocessor"></span>
00254 <span class="preprocessor">#endif</span>
00255 <span class="preprocessor"></span>
00256 <span class="comment">/*</span>
00257 <span class="comment"> * Local variables:</span>
00258 <span class="comment"> * c-file-style: "progeny"</span>
00259 <span class="comment"> * indent-tabs-mode: nil</span>
00260 <span class="comment"> * End:</span>
00261 <span class="comment"> */</span>
00262 <span class="comment">/* vim: set cin fo=tcroq sw=4 et sts=4 tw=75: */</span>
</pre></div><hr size="1"><address style="align: right;"><small>Generated on Thu Jul 28 03:38:00 2005 for discover by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.4.2 </small></address>
</body>
</html>
